# Analysis of high order dimension independent FBR-FD solution of Poisson's equation

Accompanying source to the paper presenting the solution of Poisson's equation in a `d`-dimensional domain.
The zip file contains 6 files:

  - `README.md`: this file containing usage instructions
  - `CMakeLists.txt`: CMake build file
  - `poisson.cpp`: source file that showcases basic algorithm usage
  - `dim1.xml`: XML file with parameters for `d = 1` case
  - `dim2.xml`: XML file with parameters for `d = 2` case
  - `dim3.xml`: XML file with parameters for `d = 3` case
  - `PlotSolution.ipynb`: Jupyter Notebook to plot the solutions from the produced H5 file.

To compile the example, a C++11 compliant compiler, [Medusa](http://e6.ijs.si/medusa/) library must be present on your system.

Follow these steps to obtain Figure 1 from the paper:

 1. Download the Medusa library. Follow [Medusa installation instructions](http://e6.ijs.si/medusa/download).
 2. If you encounter any HDF5 related issues during building, see [How to build](http://e6.ijs.si/medusa/wiki/index.php/How_to_build)
 3. Open `CMakeLists.txt` and edit the path to Medusa installation directory.
 4. Create new directory `build/` and go into it.
 5. Run `cmake ..` command.
 6. Run `make Poisson` command and wait to compile. First time it may take a couple minutes.
    The compilation should succeed without errors.
 7. Go one folder up and run `./build/poisson dim1.xml`. The solution is saved to a HDF5 file.
 8. Repeat for `dim2.xml` and `dim3.xml`.
 9. Run Jupyter, open `PlotSolution.ipynb`, and run all cells. You should get a plotted solution for `d=1, 2, 3` cases.
